<template>
  <div class="panel">
    <h1>Generador de plantillas</h1>
    <div class="mt-4">
      Elige la cantidad de casillas que quieres usar para tu plantilla.
    </div>
    <select v-model="selected" class="p-2 mt-2">
      <option :value="0">---</option>
      <option v-for="tkey in Object.keys(templates)" :value="tkey" :key="tkey">
        {{ templates[tkey].rows * templates[tkey].columns }}:
        {{ templates[tkey].rows }} filas x
        {{ templates[tkey].columns }} columnas
      </option>
    </select>
    <div class="mt-4">Configura algunos parámetros de la plantilla.</div>
    <div class="mt-2">
      <label for="reference"
        ><input
          type="checkbox"
          v-model="addReference"
          id="reference"
          class="mr-2"
        />Añade punto de referencia</label
      >
    </div>
    <div class="mt-2">
      <label for="demo"
        ><input type="checkbox" v-model="addDemo" id="demo" class="mr-2" />Añade
        dibujos de ejemplo</label
      >
    </div>
    <div class="mt-4" v-if="!downloadPdf">
      <button
        @click="downloadTemplate"
        class="
          bg-gray-400
          hover:bg-gray-600
          hover:text-gray-200
          px-4
          py-2
          rounded-lg
        "
      >
        Generar
      </button>
    </div>
    <div class="mt-4" v-if="downloadPdf">
      <a
        :href="downloadPdf"
        :download="fileName"
        class="
          bg-green-400
          hover:bg-green-600
          hover:text-gray-200
          px-4
          py-2
          rounded-lg
        "
        >Descarga plantilla</a
      >
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { watch } from "@vue/runtime-core";

export default {
  data() {
    return {
      addReference: true,
      addDemo: false,
      selected: 0,
      templates: {},
      downloadPdf: null,
    };
  },
  async created() {
    let templateUrl = "/api/template";
    this.templates = (await axios.get(templateUrl)).data;
    this.$watch(
      () => `${this.addDemo}-${this.addReference}-${this.selected}`,
      (newVal, oldVal) => {
        this.downloadPdf = null;
      }
    );
  },
  computed: {
    fileName() {
      return `plantilla-${this.selected}${this.addDemo ? "-demo" : ""}${
        !this.addReference ? "-noref" : ""
      }.pdf`;
    },
  },
  methods: {
    downloadTemplate() {
      let downloadUrl = `/api/template/${this.selected}`;
      axios
        .get(downloadUrl, {
          params: { demo: this.addDemo, reference: this.addReference },
          responseType: "blob",
          header: {
            "Content-Type": "application/pdf",
          },
        })
        .then((response) => {
          let fileBlob = new Blob([response.data], { type: "application/pdf" });
          let fileURL = window.URL.createObjectURL(fileBlob);
          this.downloadPdf = fileURL;
        });
    },
  },
};
</script>

<style>
</style>